/*
(x_x) NOTSONOISY
      GUILLAUME
      REYMOND
----------------------------------     
 ardugirl-test v1.1
----------------------------------
This sketch is to test the buttons of the micro games console ARDUGIRL
during the process of soldering the components on the PCB
http://www.notsonoisy.com/ardugirl
*/

#include <Arduboy2.h>
Arduboy2 arduboy;

BeepPin1 beep; 
int objectX = 0;
char displayText[60];

void setup() {
  arduboy.boot(); 
  arduboy.begin();
  //arduboy.bootLogoSpritesSelfMasked();
  arduboy.setFrameRate(25);
  beep.begin(); // Set up the hardware for playing tones
  arduboy.clear();
  commandText("Touche: ?");
  beep.tone(beep.freq(523.251), 5);
}

void loop() {
  if (!arduboy.nextFrame()) {
    return;
  }

  arduboy.setCursor(0, 0);
  beep.timer(); // handle tone duration
  arduboy.pollButtons();

  if (arduboy.justPressed(LEFT_BUTTON)) {
    beep.tone(beep.freq(523.251), 5);
    commandText("Touche: GAUCHE");
  }

  if (arduboy.justPressed(UP_BUTTON)) {
    beep.tone(beep.freq(587.330), 5);
    commandText("Touche: HAUT  ");
  }

  if (arduboy.justPressed(RIGHT_BUTTON)) {
    beep.tone(beep.freq(659.255), 5);
    commandText("Touche: DROITE");
  }

  if (arduboy.justPressed(DOWN_BUTTON)) {
    beep.tone(beep.freq(698.456), 5);
    commandText("Touche: BAS   ");
  }

  if (arduboy.justPressed(A_BUTTON)) {
    beep.tone(beep.freq(783.99), 5);
    commandText("Touche: A     ");
  }

  if (arduboy.justPressed(B_BUTTON)) {
    beep.tone(beep.freq(880), 5);
    commandText("Touche: B     ");
  }

  arduboy.println(F("(x_x) NOTSONOISY"));
  arduboy.println(F("      GUILLAUME"));
  arduboy.println(F("      REYMOND"));
  arduboy.println(F("---------------------"));
  arduboy.println(F(" ARDUGIRL - T E S T"));
  arduboy.println(F("---------------------"));
  arduboy.println(displayText);

  // then we finaly we tell the arduboy to display what we just wrote to the display
  arduboy.display();
}

void commandText(const char* text) {
  strncpy(displayText, text, sizeof displayText);
  displayText[sizeof displayText - 1] = '\0';
}
