#ifndef rooms_h
#define rooms_h

#include "tiles.h"
#include "direction.h"

struct EnemyDef {
    const uint8_t x;
    const uint8_t y;
    const Direction facing;
    const uint8_t type;
};

struct RoomDef {
    const uint8_t (*tiles)[ROOM_TILE_WIDTH];
    const EnemyDef *enemies;
};


const uint8_t upperCenterRoomTiles[ROOM_TILE_HEIGHT][ROOM_TILE_WIDTH] = {
    {STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {PLAIN_FLOOR, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR}
};

const RoomDef upperCenterRoomDef = {
    upperCenterRoomTiles,
    NULL
};

const uint8_t upperLeftRoomTiles[ROOM_TILE_HEIGHT][ROOM_TILE_WIDTH] = {
    {STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL},
    {STONE_WALL, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {STONE_WALL, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {STONE_WALL, PLAIN_FLOOR, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {STONE_WALL, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {STONE_WALL, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {STONE_WALL, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {STONE_WALL, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR}
};

const RoomDef upperLeftRoomDef = {
    upperLeftRoomTiles,
    NULL
};


const uint8_t lowerCenterRoomTiles[ROOM_TILE_HEIGHT][ROOM_TILE_WIDTH] = {
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL}
};

const RoomDef lowerCenterRoomDef = {
    lowerCenterRoomTiles,
    NULL
};

const uint8_t lowerRightRoomTiles[ROOM_TILE_HEIGHT][ROOM_TILE_WIDTH] = {
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, STONE_WALL},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, STONE_WALL},
    {PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, STONE_WALL},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, STONE_WALL},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, STONE_WALL},
    {PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, STONE_WALL},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, STONE_WALL},
    {STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL}
};

const RoomDef lowerRightRoomDef = {
    lowerRightRoomTiles,
    NULL
};

const uint8_t upperRightRoomTiles[ROOM_TILE_HEIGHT][ROOM_TILE_WIDTH] = {
    {STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, STONE_WALL},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, STONE_WALL},
    {PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, STONE_WALL},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, STONE_WALL},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, STONE_WALL},
    {PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, STONE_WALL},
    {PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, STONE_WALL},
};

const RoomDef upperRightRoomDef = {
    upperRightRoomTiles,
    NULL
};

const uint8_t lowerLeftRoomTiles[ROOM_TILE_HEIGHT][ROOM_TILE_WIDTH] = {
    {STONE_WALL, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {STONE_WALL, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {STONE_WALL, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {STONE_WALL, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {STONE_WALL, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {STONE_WALL, DIRT_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {STONE_WALL, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR, PLAIN_FLOOR},
    {STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL, STONE_WALL}
};

const RoomDef lowerLeftRoomDef = {
    lowerLeftRoomTiles,
    NULL
};

#endif
